src/AppBundle/Entity/Votable.php
<?php

namespace Raddit\AppBundle\Entity;

use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\Criteria;
use Doctrine\Common\Collections\Selectable;

abstract class Votable {
    /**
     * @return Vote[]|Collection|Selectable
     */
    abstract public function getVotes();

    /**
     * @return Vote
     */
    abstract public function createVote();

    /**
     * @return int
     */
    public function getUpvotes() {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->eq('upvote', true));

        return count($this->getVotes()->matching($criteria));
    }

    /**
     * @return int
     */
    public function getDownvotes() {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->eq('upvote', false));

        return count($this->getVotes()->matching($criteria));
    }

    /**
     * @return int
     */
    public function getNetScore() {
        return $this->getUpvotes() - $this->getDownvotes();
    }

    /**
     * @param User $user
     *
     * @return Vote|null
     */
    public function getUserVote(User $user) {
        $criteria = Criteria::create();
        $criteria->where(Criteria::expr()->eq('user', $user));

        return $this->getVotes()->matching($criteria)->first();
    }

    /**
     * @param Votable $a
     * @param Votable $b
     *
     * @return int
     */
    final public static function descendingNetScoreCmp(self $a, self $b) {
        return $b->getNetScore() <=> $a->getNetScore();
    }
}

src/AppBundle/Resources/views/base.html.twig
<!DOCTYPE html>
<html lang="{{ app.request.locale|split('_')[0] }}">
  <head>
    <meta charset="UTF-8" />
    <title>{% block title %}{{ raddit_app_site_name() }}{% endblock %}</title>
    <link rel="icon" type="image/x-icon" href="{{ asset('favicon.ico') }}">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    {% block stylesheets %}
      <link rel="stylesheet" href="{{ asset('css/main.min.css') }}">
    {% endblock %}

    {% block head %}{% endblock %}
  </head>

  <body class="{{ block('page_classes')|replace({'\n': ''}) }} {{ app.user ? 'user-logged-in' : 'user-anonymous' }}">
    {% spaceless %}
      <nav class="site-nav">
        <ul>
          {% block site_nav_left %}
            <li><a href="{{ path('raddit_app_front') }}">{{ raddit_app_site_name() }}</a></li>
          {% endblock %}
        </ul>

        <ul class="right-nav">
          {% if not is_granted('ROLE_USER') %}
            <li><a href="{{ path('raddit_app_login') }}">{{ 'site_nav.log_in'|trans }}</a></li>
            <li><a href="{{ path('raddit_app_registration') }}">{{ 'site_nav.register'|trans }}</a></li>
          {% else %}
            <li><a href="{{ path('raddit_app_create_forum') }}">{{ 'create_forum.nav_link'|trans }}</a></li>
            <li><a href="{{ path('raddit_app_submit', {forum_name: forum is defined and forum ? forum.name : null}) }}">{{ 'site_nav.submit'|trans }}</a></li>
            <li class="dropdown-container">
              <a href="#" class="dropdown-toggle"><strong>{{ app.user.username }}</strong></a>
              <ul class="dropdown-menu">
                <li><a href="{{ path('raddit_app_user', {username: app.user.username}) }}">{{ 'site_nav.profile'|trans }}</a></li>
                <li><a href="{{ path('raddit_app_edit_user', {username: app.user.username}) }}">{{ 'site_nav.my_account'|trans }}</a></li>
                <li><a href="{{ logout_path() }}">{{ 'site_nav.log_out'|trans }}</a></li>
              </ul>
            </li>
          {% endif %}
        </ul>
      </nav>
    {% endspaceless %}

    <div class="site-alerts">
      {%- if app.request.hasPreviousSession -%}
        {%- for type, notices in app.session.flashBag.all -%}
          {%- for notice in notices -%}
            <p class="alert alert-{{ type }}" role="alert">{{ notice|trans }}</p>
          {%- endfor -%}
        {%- endfor -%}
      {%- endif -%}
    </div>

    <div class="content-wrapper">
      <aside class="sidebar">{% block sidebar %}{% endblock %}</aside>
      <section class="body">{% block body %}{% endblock %}</section>
    </div>

    {% block javascripts %}
      <script>window.__webpack_public_path__ = "{{ app.request.baseUrl|e('js') }}/js/";</script>
      <script src="{{ asset('js/vendor.min.js') }}"></script>
      <script src="{{ asset('js/main.min.js') }}"></script>
      <script src="{{ path('bazinga_jstranslation_js') }}"></script>
    {% endblock %}
  </body>
</html>

src/AppBundle/Resources/views/comment-form-errors.html.twig
{% extends '@RadditApp/submission-base.html.twig' %}

{% from '@RadditApp/macros/comments.html.twig' import comment %}

{% block title %}
  {% if editing %}
    {{ 'comment_form.edit_title'|trans }}
  {% else %}
    {{ 'comment_form.create_title'|trans }}
  {% endif %}
{% endblock %}

{% block page_classes %}
  comment-form-error-page
{% endblock %}

{% block body %}
  <h1>{{ block('title') }}</h1>

  {% if comment %}
    {{ comment(comment, false) }}
  {% endif %}

  {% include '@RadditApp/forms/comment-form.html.twig' with { form: form } only %}
{% endblock %}

src/AppBundle/Resources/views/comment.html.twig
{% extends '@RadditApp/submission-base.html.twig' %}

{% from '@RadditApp/macros/comments.html.twig' import comment, comment_form %}
{% from '@RadditApp/macros/submissions.html.twig' import submission %}

{% block page_classes %}
  single-comment-page
{% endblock %}

{% block body %}
  {{ submission(submission) }}

  <nav class="comment-thread-nav">
    <h1>{{ 'comments.viewing_thread'|trans }}</h1>

    <ul>
      <li>
        <a href="{{ path('raddit_app_comments', {forum_name: forum.name, submission_id: submission.id, }) }}">
          {{- 'comments.thread_return'|trans -}}
        </a>
      </li>
    </ul>
  </nav>

  {{ comment(comment) }}

  {{ comment_form(submission, comment) }}
{% endblock %}

src/AppBundle/Resources/views/create-forum.html.twig
{% extends '@RadditApp/base.html.twig' %}

{% form_theme form '@RadditApp/forms/standard-form-theme.html.twig' %}

{% block page_classes %}create-forum-page{% endblock %}

{% block title %}{{ 'create_forum.create_new_forum'|trans }}{% endblock %}

{% block body %}
  {{ form_start(form) }}
  {{ form_end(form) }}
{% endblock %}

src/AppBundle/Resources/views/edit-forum.html.twig
{% extends '@RadditApp/forum-base.html.twig' %}
{% form_theme form '@RadditApp/forms/standard-form-theme.html.twig' %}

{% block page_classes %}edit-forum-page{% endblock %}

{% block title %}{{ 'edit_forum.title'|trans({'%forum%': forum.name}) }}{% endblock %}

{% block body %}
  {{ form_start(form) }}
    {{ form_row(form.name) }}

    {{ form_row(form.title) }}

    {{ form_row(form.description) }}

    {{ form_row(form.submit) }}

    {% if form.delete is defined %}
      {{ form_row(form.delete, {attr: {class: 'delete-forum'}}) }}
    {% endif %}
  {{ form_end(form) }}
{% endblock %}

{% block javascripts %}
  {{ parent() }}

  <script>
    $('.delete-forum').click(function () {
      return confirm(Translator.trans('forum_form.confirm_delete'));
    });
  </script>
{% endblock %}

src/AppBundle/Resources/views/edit-user.html.twig
{% extends '@RadditApp/base.html.twig' %}

{% form_theme form '@RadditApp/forms/standard-form-theme.html.twig' %}

{% block title %}{{ 'edit_user.title'|trans({'%username%': user.username}) }}{% endblock %}

{% block page_classes %}edit-user-page{% endblock %}

{% block body %}
  <h1>{{ block('title') }}</h1>

  {{ form(form) }}
{% endblock %}

src/AppBundle/Resources/views/forum-base.html.twig
{% extends '@RadditApp/base.html.twig' %}

{% spaceless %}
  {% block sidebar %}
    <section class="forum-meta">
      <h1 class="forum-title"><a href="{{ path('raddit_app_forum', {forum_name: forum.name}) }}">{{ forum.title }}</a></h1>

      {% if is_granted('ROLE_USER') %}
        {% set subscribed = app.user.subscriptionByForum(forum) is not null %}
        <form action="{{ path(subscribed ? 'raddit_app_unsubscribe' : 'raddit_app_subscribe', {id: forum.id}) }}" method="POST">
          <input type="hidden" name="token" value="{{ csrf_token('subscribe') }}">

          <p>
            <button class="forum-subscribe-button">
              {{- (subscribed ? 'forum.unsubscribe' : 'forum.subscribe')|trans -}}
            </button>

            <span class="forum-subscriber-count">
              {{ 'forum.subscriber_count'|transchoice(forum.subscriptions|length) }}
            </span>
          </p>
        </form>
      {% endif %}

      {% if forum.description %}
        <div class="forum-description">{{ forum.description|cached_markdown|raw }}</div>
      {% endif %}
    </section>

    {% if is_granted('edit', forum) %}
      <section class="forum-manage">
        <h1>{{ 'forum.manage'|trans }}</h1>
        <ul>
          <li><a href="{{ path('raddit_app_edit_forum', {forum_name: forum.name}) }}">{{ 'forum.edit'|trans }}</a></li>
        </ul>
      </section>
    {% endif %}

    {% if forum.moderators|length > 0 %}
      <section class="forum-moderators">
        <h1>{{ 'forum.moderators'|trans }}</h1>
        <ul>
          {% for moderator in forum.moderators %}
            <li>
              <a href="{{ path('raddit_app_user', {username: moderator.user.username}) }}">
                {{- moderator.user.username -}}
              </a>
            </li>
          {% endfor %}
        </ul>
      </section>
    {% endif %}
  {% endblock %}
{% endspaceless %}

src/AppBundle/Resources/views/forum.html.twig
{% extends '@RadditApp/forum-base.html.twig' %}

{% from '@RadditApp/macros/submissions.html.twig' import submission, submission_sort %}

{% block title %}{{ forum.title }}{% endblock %}

{% block head %}
  <link rel="canonical" href="{{ url('raddit_app_forum', {forum_name: forum.name}) }}">

  {% if forum.description %}
    <meta name="description" content="{{ forum.description|markdown|striptags }}">
  {% endif %}
{% endblock %}

{% block page_classes %}forum-front{% endblock %}

{% block body %}
  {{ submission_sort(sort_by) }}

  {% for submission in submissions %}
    {{ submission(submission, {show_forum_name: false}) }}
  {% endfor %}
{% endblock %}

src/AppBundle/Resources/views/registration.html.twig
{% extends '@RadditApp/base.html.twig' %}

{% form_theme form '@RadditApp/forms/standard-form-theme.html.twig' %}

{% block page_classes %}registration-page{% endblock %}

{% block body %}
  {{ form_start(form) }}
  {{ form_end(form) }}
{% endblock %}

src/AppBundle/Resources/views/request-password-reset.html.twig
{% extends '@RadditApp/base.html.twig' %}

{% form_theme form '@RadditApp/forms/standard-form-theme.html.twig' %}

{% block page_classes %}
  request-password-reset-page
{% endblock %}

{% block title %}
  {{ 'request_password_reset.title'|trans }}
{% endblock %}

{% block body %}
  <h1>{{ block('title') }}</h1>

  <p>{{ 'request_password_reset.no_confirmation_notice'|trans }}</p>
  <p>{{ 'request_password_reset.multiple_accounts_notice'|trans }}</p>

  {{ form(form) }}
{% endblock %}

src/AppBundle/Resources/views/reset-password.html.twig
{% extends '@RadditApp/base.html.twig' %}

{% form_theme form '@RadditApp/forms/standard-form-theme.html.twig' %}

{% block page_classes %}
  reset-password-page
{% endblock %}

{% block title %}{{ 'reset_password.title'|trans }}{% endblock %}

{% block body %}
  <h1>{{ block('title') }}</h1>

  {{ form(form) }}
{% endblock %}

src/AppBundle/Resources/views/submission-base.html.twig
{% extends '@RadditApp/forum-base.html.twig' %}

{% block sidebar %}
  <section class="sidebar-submission-meta">
    <p class="sidebar-submission-meta-score">
      <strong class="vote-total">{{- 'submissions.total_votes'|transchoice(submission.votes|length) -}}</strong>
      <span class="vote-stats">{{ 'submissions.vote_stats'|trans({
          '%up%': submission.upvotes,
          '%down%': submission.downvotes,
        }) }}</span>
    </p>
  </section>

  {{ parent() }}
{% endblock %}

src/AppBundle/Resources/views/submit.html.twig
{% extends forum is defined and forum ? '@RadditApp/forum-base.html.twig' : '@RadditApp/base.html.twig' %}
{% form_theme form '@RadditApp/forms/standard-form-theme.html.twig' %}

{% block page_classes %}submit-page{% endblock %}

{% block body %}
  {{ form_start(form) }}
    {{ form_row(form.title, {attr: {rows: 3}}) }}

    {{ form_row(form.url) }}

    {{ form_row(form.body, {attr: {rows: 10}}) }}

    {% if form.forum is defined %}
      {{ form_row(form.forum) }}
    {% endif %}

    {{ form_row(form.submit) }}

    {% if form.delete is defined %}
      {{ form_row(form.delete, {attr: {class: 'delete-submission'}}) }}
    {% endif %}
  {{ form_end(form) }}
{% endblock %}

{% block javascripts %}
  {{ parent() }}

  <script>
    $('.delete-submission').click(function () {
        return confirm(Translator.trans('submission_form.confirm_delete'));
    });
  </script>
{% endblock %}

src/AppBundle/Resources/views/user.html.twig
{% extends '@RadditApp/base.html.twig' %}

{% from '@RadditApp/macros/submissions.html.twig' import submission %}
{% from '@RadditApp/macros/comments.html.twig' import comment %}

{% block title %}{{ user.username }}{% endblock %}

{% block page_classes %}
  user-page
{% endblock %}

{% block body %}
  <div class="container user-submissions">
    <h2>{{ 'user.submissions'|trans }}</h2>
    {% for submission in submissions %}
      {{ submission(submission) }}
    {% endfor %}
  </div>

  <div class="container user-comments">
    <h2>{{ 'user.comments'|trans }}</h2>
    {% for comment in comments %}
      {{ comment(comment, false) }}
    {% endfor %}
  </div>

  {% if user.moderatorTokens|length %}
    <div class="container">
      <h2>{{ 'user.moderates'|trans({'%username%': user.username}) }}</h2>
      <ul>
        {% for token in user.moderatorTokens %}
          <li>
            <a href="{{ path('raddit_app_forum', {forum_name: token.forum.name}) }}">
              {{- token.forum.name -}}
            </a>
          </li>
        {% endfor %}
      </ul>
    </div>
  {% endif %}
{% endblock %}